﻿------------------------------------------------------------------------------------
-- NiceColorize by Mr.Dio (MrDio#2565) Version 2.4 (22:06 25.08.2016)
------------------------------------------------------------------------------------
--
-- Frames Colorize Module
--
------------------------------------------------------------------------------------
-- NiceColorize
------------------------------------------------------------------------------------

function FramesColorizeModule_Init(Cfg)

	if not IsAddOnLoaded("Blizzard_TimeManager") then
		LoadAddOn("Blizzard_TimeManager")
	end

	local ClassColor = RAID_CLASS_COLORS[select(2, UnitClass("player"))]

	if Cfg.Class then
		Cfg.TopColor.Red, Cfg.TopColor.Green, Cfg.TopColor.Blue = (ClassColor.r * 1.2), (ClassColor.g * 1.2), (ClassColor.b * 1.2)
	end


	FCFrames = {

 			ArenaEnemyFrame1Texture,
			ArenaEnemyFrame2Texture,
			ArenaEnemyFrame3Texture,
			ArenaEnemyFrame4Texture,
			ArenaEnemyFrame5Texture,
			ArenaEnemyFrame1SpecBorder,
			ArenaEnemyFrame2SpecBorder,
			ArenaEnemyFrame3SpecBorder,
			ArenaEnemyFrame4SpecBorder,
			ArenaEnemyFrame5SpecBorder,
			ArenaEnemyFrame1PetFrameTexture,
			ArenaEnemyFrame2PetFrameTexture,
			ArenaEnemyFrame3PetFrameTexture,
			ArenaEnemyFrame4PetFrameTexture,
			ArenaEnemyFrame5PetFrameTexture,
			TimerTrackerTimer1StatusBarBorder,

				ArenaPrepFrame1Texture,
				ArenaPrepFrame2Texture,
				ArenaPrepFrame3Texture,
				ArenaPrepFrame4Texture,
				ArenaPrepFrame5Texture,
				ArenaPrepFrame1SpecBorder,
				ArenaPrepFrame2SpecBorder,
				ArenaPrepFrame3SpecBorder,
				ArenaPrepFrame4SpecBorder,
				ArenaPrepFrame5SpecBorder,
				TimerTrackerTimer1StatusBarBorder,

 				ArenaEnemyFrame1Texture,
				ArenaEnemyFrame2Texture,
				ArenaEnemyFrame3Texture,
				ArenaEnemyFrame4Texture,
				ArenaEnemyFrame5Texture,
				ArenaEnemyFrame1SpecBorder,
				ArenaEnemyFrame2SpecBorder,
				ArenaEnemyFrame3SpecBorder,
				ArenaEnemyFrame4SpecBorder,
				ArenaEnemyFrame5SpecBorder,
				ArenaEnemyFrame1PetFrameTexture,
				ArenaEnemyFrame2PetFrameTexture,
				ArenaEnemyFrame3PetFrameTexture,
				ArenaEnemyFrame4PetFrameTexture,
				ArenaEnemyFrame5PetFrameTexture,
				TimerTrackerTimer1StatusBarBorder,


		MainMenuBarLeftEndCap,
    MainMenuBarRightEndCap,
		StanceBarLeft,
		StanceBarMiddle,
		StanceBarRight,


		SlidingActionBarTexture0,
		SlidingActionBarTexture1,
    MainMenuBarTexture0,
		MainMenuBarTexture1,
		MainMenuBarTexture2,
		MainMenuBarTexture3,
    MainMenuMaxLevelBar0,
    MainMenuMaxLevelBar1,
		MainMenuMaxLevelBar2,
		MainMenuMaxLevelBar3,
		MainMenuXPBarTextureLeftCap,
		MainMenuXPBarTextureRightCap,
		MainMenuXPBarTextureMid,
		ReputationWatchBarTexture0,
		ReputationWatchBarTexture1,
		ReputationWatchBarTexture2,
		ReputationWatchBarTexture3,
		ReputationXPBarTexture0,
		ReputationXPBarTexture1,
		ReputationXPBarTexture2,
		ReputationXPBarTexture3,

--GetDrawLayer() == "BORDER", WarlockPowerFrameShard1-5:GetRegions()


			CastingBarFrameBorder,


				PlayerFrameTexture,
				PlayerFrameAlternateManaBarBorder,
				PlayerFrameAlternateManaBarLeftBorder,
				PlayerFrameAlternateManaBarRightBorder,
				AlternatePowerBarBorder,
				AlternatePowerBarLeftBorder,
				AlternatePowerBarRightBorder,
   			TargetFrameTextureFrameTexture,
  		  PetFrameTexture,
				PartyMemberFrame1Texture,
				PartyMemberFrame2Texture,
				PartyMemberFrame3Texture,
				PartyMemberFrame4Texture,
				PartyMemberFrame1PetFrameTexture,
				PartyMemberFrame2PetFrameTexture,
				PartyMemberFrame3PetFrameTexture,
				PartyMemberFrame4PetFrameTexture,
   		  FocusFrameTextureFrameTexture,
   		  TargetFrameToTTextureFrameTexture,
   			FocusFrameToTTextureFrameTexture,
				Boss1TargetFrameTextureFrameTexture,
				Boss2TargetFrameTextureFrameTexture,
				Boss3TargetFrameTextureFrameTexture,
				Boss4TargetFrameTextureFrameTexture,
				Boss5TargetFrameTextureFrameTexture,
				Boss1TargetFrameSpellBar.Border,
				Boss2TargetFrameSpellBar.Border,
				Boss3TargetFrameSpellBar.Border,
				Boss4TargetFrameSpellBar.Border,
				Boss5TargetFrameSpellBar.Border,
				CastingBarFrame.Border,
				FocusFrameSpellBar.Border,
				TargetFrameSpellBar.Border,
				PaladinPowerBarFrameBG,
				PaladinPowerBarFrameBankBG,
        ComboPointPlayerFrame.Background,
        ComboPointPlayerFrame.Combo1.PointOff,
        ComboPointPlayerFrame.Combo2.PointOff,
        ComboPointPlayerFrame.Combo3.PointOff,
        ComboPointPlayerFrame.Combo4.PointOff,
        ComboPointPlayerFrame.Combo5.PointOff,
				HonorWatchBar.StatusBar.XPBarTexture0,
				HonorWatchBar.StatusBar.XPBarTexture1,
        HonorWatchBar.StatusBar.XPBarTexture2,
				HonorWatchBar.StatusBar.XPBarTexture3,

BonusActionBarFrameTexture0,
BonusActionBarFrameTexture1,
BonusActionBarFrameTexture2,
BonusActionBarFrameTexture3,
BonusActionBarFrameTexture4,

MinimapBorder,
FocusFrameSpellBarBorder,
TargetFrameSpellBarBorder,
MiniMapTrackingButtonBorder,
MiniMapLFGFrameBorder,
MiniMapBattlefieldBorder,
MiniMapMailBorder,
MinimapBorderTop,
select(1, TimeManagerClockButton:GetRegions()),
select(2, TimeManagerClockButton:GetRegions()),

		select(2, GarrisonLandingPageMinimapButton:GetRegions()),
		
		select(2, FriendsMicroButton:GetRegions()),
		ChatFrameMenuButton:GetRegions(),
		ChatFrame1ButtonFrameUpButton:GetRegions(),
		ChatFrame1ButtonFrameDownButton:GetRegions(),
		select(2, ChatFrame1ButtonFrameBottomButton:GetRegions()),
		ChatFrame2ButtonFrameUpButton:GetRegions(),
		ChatFrame2ButtonFrameDownButton:GetRegions(),
		select(2, ChatFrame2ButtonFrameBottomButton:GetRegions()),
		
		select(6, ChatFrame1EditBox:GetRegions()),
		select(7, ChatFrame1EditBox:GetRegions()),
		select(8, ChatFrame1EditBox:GetRegions()),
		
		select(2, CharacterMicroButton:GetRegions()),
		select(3, CharacterMicroButton:GetRegions()),
		select(2, SpellbookMicroButton:GetRegions()),
		select(2, TalentMicroButton:GetRegions()),
		select(2, AchievementMicroButton:GetRegions()),
		select(2, QuestLogMicroButton:GetRegions()),
		select(2, GuildMicroButton:GetRegions()),

		select(2, LFDMicroButton:GetRegions()),
		select(2, CollectionsMicroButton:GetRegions()),
		select(2, EJMicroButton:GetRegions()),
		select(2, StoreMicroButton:GetRegions()),
		select(4, MainMenuMicroButton:GetRegions()),

		QueueStatusMinimapButton:GetRegions(),
		MinimapBackdrop,
		MinimapZoneTextButton,
		MiniMapWorldMapButton,
		MiniMapWorldIcon,
		MiniMapInstanceDifficulty:GetRegions(),
		MinimapZoomIn:GetRegions(),
		select(3, MinimapZoomIn:GetRegions()),
		MinimapZoomOut:GetRegions(),
		select(3, MinimapZoomOut:GetRegions()),
		MiniMapWorldMapButton:GetRegions(),
		select(6, GameTimeFrame:GetRegions()),

		MainMenuXPBarDiv1,
		MainMenuXPBarDiv2,
		MainMenuXPBarDiv3,
		MainMenuXPBarDiv4,
		MainMenuXPBarDiv5,
		MainMenuXPBarDiv6,
		MainMenuXPBarDiv7,
		MainMenuXPBarDiv8,
		MainMenuXPBarDiv9,
		MainMenuXPBarDiv10,
		MainMenuXPBarDiv11,
		MainMenuXPBarDiv12,
		MainMenuXPBarDiv13,
		MainMenuXPBarDiv14,
		MainMenuXPBarDiv15,
		MainMenuXPBarDiv16,
		MainMenuXPBarDiv17,
		MainMenuXPBarDiv18,
		MainMenuXPBarDiv19,
select(2, PlayerFrameAlternateManaBar:GetRegions()),
		ActionBarUpButton:GetRegions(),
		ActionBarDownButton:GetRegions(),
ShapeshiftBarLeft,
		ShapeshiftBarMiddle,
		ShapeshiftBarRight,


	}
	
	--/run v=select(1, GuildMicroButtonTabard:GetRegions()) v:SetVertexColor(1, 1, 1)

	function Colorize(frame, R, G, B)
		if not frame.IsColorize then
			frame.IsColorize = true
			frame.DefColorR, frame.DefColorG, frame.DefColorB, frame.DefColorA = frame:GetVertexColor()
		end
		if Cfg.Gradient then
			frame:SetGradientAlpha("VERTICAL", Cfg.BottomColor.Red, Cfg.BottomColor.Green, Cfg.BottomColor.Blue, Cfg.BottomColor.Alpha, R, G, B, Cfg.TopColor.Alpha)
		else
			frame:SetVertexColor(R, G, B, Cfg.TopColor.Alpha)
		end
	end

	function DeColorize(frame)
		if frame.IsColorize then
			frame:SetVertexColor(frame.DefColorR, frame.DefColorG, frame.DefColorB, frame.DefColorA)
			frame.IsColorize = false
		end
	end
	return true
end

function FramesColorizeModule_Update(Cfg)

	if Cfg.ModuleEnable then
	
		local ClassColor = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
	
		if Cfg.Class then
			R, G, B = (ClassColor.r * 1.2), (ClassColor.g * 1.2), (ClassColor.b * 1.2)
		else
			R, G, B = Cfg.TopColor.Red, Cfg.TopColor.Green, Cfg.TopColor.Blue
		end

		for _, f in ipairs({ Minimap:GetChildren() }) do
			if (f and ( f:GetObjectType() == "Frame" or f:GetObjectType() == "Button") ) then
				for _, tex in ipairs({ f:GetRegions() }) do
					if (tex and tex:GetObjectType() == "Texture") then
						if tex:GetTexture() ==	"Interface\\Minimap\\MiniMap-TrackingBorder" then
							Colorize(tex, R, G, B)
						end 
					end
				end 
			end
		end

		for i, v in pairs(FCFrames) do
			if v:GetObjectType() == "Texture" then
				Colorize(v, R, G, B)
			end
		end
		
	--[[	local Date = select(5, GameTimeFrame:GetRegions())
		if not Date.IsColorize then
			Date.DefFont, Date.DefSize, Date.DefStyle  = Date:GetFont()
			Date.DefColorR, Date.DefColorG, Date.DefColorB, Date.DefColorA = Date:GetTextColor()
			Date.IsColorize = true
		end
		Date:SetTextColor(1, 1, 1)
		Date:SetFont(Date.DefFont, Date.DefSize, "OUTLINE")]]--
		
		if not MainMenuBarLeftEndCap.IsColorize then
			MainMenuBarLeftEndCap.IsColorize = true
			MainMenuBarLeftEndCap.DefColorR, MainMenuBarLeftEndCap.DefColorG, MainMenuBarLeftEndCap.DefColorB, MainMenuBarLeftEndCap.DefColorA = MainMenuBarLeftEndCap:GetVertexColor()
		end
		
		if not MainMenuBarRightEndCap.IsColorize then
			MainMenuBarRightEndCap.IsColorize = true
			MainMenuBarRightEndCap.DefColorR, MainMenuBarRightEndCap.DefColorG, MainMenuBarRightEndCap.DefColorB, MainMenuBarRightEndCap.DefColorA = MainMenuBarRightEndCap:GetVertexColor()
		end
		
		if Cfg.Gradient then
			MainMenuBarLeftEndCap:SetGradientAlpha("HORIZONTAL", Cfg.BottomColor.Red, Cfg.BottomColor.Green, Cfg.BottomColor.Blue, Cfg.BottomColor.Alpha, R, G, B, Cfg.TopColor.Alpha)
			MainMenuBarRightEndCap:SetGradientAlpha("HORIZONTAL", R, G, B, Cfg.TopColor.Alpha, Cfg.BottomColor.Red, Cfg.BottomColor.Green, Cfg.BottomColor.Blue, Cfg.BottomColor.Alpha)
		else
			MainMenuBarLeftEndCap:SetVertexColor(R, G, B, Cfg.TopColor.Alpha)
			MainMenuBarRightEndCap:SetVertexColor(R, G, B, Cfg.TopColor.Alpha)
		end
		
		TOOLTIP_DEFAULT_COLOR = { r = R * 0.5, g = G * 0.5, b = B * 0.5 }
		TOOLTIP_DEFAULT_BACKGROUND_COLOR = { r = R * 0.2, g = G * 0.2, b = B * 0.2}
	
	else
	
		if not IsAddOnLoaded("Blizzard_TimeManager") then
			LoadAddOn("Blizzard_TimeManager")
		end
		
	--[[	local Date = select(5, GameTimeFrame:GetRegions())
		if Date.IsColorize then
			Date:SetTextColor(Date.DefColorR, Date.DefColorG, Date.DefColorB, Date.DefColorA)
			Date:SetFont(Date.DefFont, Date.DefSize, "OUTLINE")
			Date.IsColorize = false
		end]]--
	
		for _, f in ipairs({ Minimap:GetChildren() }) do
			if (f and ( f:GetObjectType() == "Frame" or f:GetObjectType() == "Button") ) then
				for _, tex in ipairs({ f:GetRegions() }) do
					if (tex and tex:GetObjectType() == "Texture") then
						if tex:GetTexture() ==	"Interface\\Minimap\\MiniMap-TrackingBorder" then
							DeColorize(tex)
						end 
					end
				end 
			end
		end

		for i, v in pairs(FCFrames) do
			if v:GetObjectType() == "Texture" then
				DeColorize(v)
			end
		end
		
		if MainMenuBarLeftEndCap.IsColorize then
			MainMenuBarLeftEndCap.IsColorize = false
			MainMenuBarLeftEndCap:SetVertexColor(MainMenuBarLeftEndCap.DefColorR, MainMenuBarLeftEndCap.DefColorG, MainMenuBarLeftEndCap.DefColorB, MainMenuBarLeftEndCap.DefColorA)
		end
		
		if MainMenuBarRightEndCap.IsColorize then
			MainMenuBarRightEndCap.IsColorize = false
			MainMenuBarRightEndCap:SetVertexColor(MainMenuBarRightEndCap.DefColorR, MainMenuBarRightEndCap.DefColorG, MainMenuBarRightEndCap.DefColorB, MainMenuBarRightEndCap.DefColorA)
		end
		
		TOOLTIP_DEFAULT_COLOR = { r = 1, g = 1, b = 1 }
		TOOLTIP_DEFAULT_BACKGROUND_COLOR = { r = 0.09, g = 0.09, b = 0.19 }
	
	end
end